#!/usr/bin/perl 
# $Id: apop_pw.pl,v 1.4.2.1 2002/01/17 04:59:40 pbaltz Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
#
# This handler maintains a version of the user's password
# for use in the APOP database. If we don't maintain this, you
# would need to have the user's password any time you wanted to 
# enable APOP for that person (user mod, vsite apop re-enable).
#
# Plus, even if you know the password, things get messy when you
# cannot set properties in different namespaces at the same time.
# You would have to allow a set to the apop property to succeed
# and then hope that the password gets set next to actually make
# the change.

my $cce = new CCE;
$cce->connectfd();

my $user_obj = $cce->event_object();

$pw = make_pw($user_obj->{password});
my($ok) = $cce->set( $cce->event_oid(), 'APOP', { 'apop_password' => $pw } );

if ( !$ok ) {
	$cce->bye('FAIL');
	exit 1;
}

$cce->bye('SUCCESS');

# creates a password suitable for the APOP database
# params: plaintext password
# returns: apop password; '.= chr(0) . chr(0)' to the result 
#          before adding to db
sub make_pw
{
	my $plain = shift;
	my $crypt;

	foreach ( unpack('C*', $plain) ) {
		$crypt .= pack('C*', $_ ^= hex('ff'));
	}

	return $crypt;
}

exit 0;

1;
