#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
# $Id: default_state.pl,v 1.1.2.2 2002/02/23 00:05:24 jcheng Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# 
# ActiveMonitor.{Email,POP,SMTP,IMAP}.currentState handler
# Resets the NOINFO state of the namespace to be GREEN
# This way, the admin will be notified of any changes going to YELLOW
# or RED that happen immediately after bootup

use strict;
use CCE;

my $cce = new CCE;
$cce->connectfd();

# retreive object data:
my $oid = $cce->event_oid();
my $ns = $cce->event_namespace();
my ($ok, $obj, $oldobj, $newobj) = $cce->get($oid, $ns);

# NOINFO is okay if tests are disabled
# see top of file comments for more details
if (($obj->{currentState} eq 'N') && $obj->{enabled} && $obj->{monitor}) {
    ($ok) = $cce->set($oid, $ns, { currentState => 'G', 
				   currentMessage => $obj->{greenMsg}, 
				   lastChange => time() });
    if (!$ok) {
	$cce->bye('FAIL');
	exit 0;
    }
}

$cce->bye('SUCCESS');
exit 0;
