#!/usr/bin/perl -w -I/usr/sausalito/perl
# $Id: enable.pl,v 1.19 2001/11/14 18:25:45 will Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.

use Sauce::Service;
use CCE;

my $DEBUG = 0;
$DEBUG && open(STDERR, ">>/tmp/email.enable");
$DEBUG && warn `date`;

my $cce = new CCE( Namespace => 'Email',
                      Domain => 'base-email' );

$cce->connectfd();

my $obj = $cce->event_object();
my %settings;
$settings{'imap'} = $obj->{enableImap} ? 'on' : 'off';
if ($obj->{enablePop}) {
    $DEBUG && warn "Pop enabled\n";
    $settings{'pop-3'} = 'on';
    # we never want POP2 to be on
    $settings{'pop-2'} = 'off';
} else {
    $DEBUG && warn "Pop disabled\n";
    $settings{'pop-3'} = 'off';
    $settings{'pop-2'} = 'off';
}

# Obtain connection rates
my($imapRate, $popRate) = ($obj->{imapConnectRate}, $obj->{popConnectRate});
$imapRate ||= 1024;
$popRate ||= 80;

# inetd settings first
Sauce::Service::service_set_inetd('pop-3', $settings{'pop-3'}, $popRate);
Sauce::Service::service_set_inetd('pop-2', $settings{'pop-2'}, $popRate);
Sauce::Service::service_set_inetd('imap', $settings{'imap'}, $imapRate);
Sauce::Service::service_send_signal('inetd', 'HUP');

# don't trust anyone on the current state. there should be no delay
# on stoppage.
Sauce::Service::service_toggle_init('sendmail', $obj->{enableSMTP});

# pop-before-smtp relaying
my $popRelay = Sauce::Service::service_get_init('poprelayd') ? 'on' : 'off';
my $newpopRelay = $obj->{popRelay} ? 'on' : 'off';

$DEBUG && warn "Think poprelayd is running? $popRelay\nShould be? $newpopRelay\n";

Sauce::Service::service_toggle_init('poprelayd', $obj->{popRelay}); 

if($newpopRelay eq 'on') {
	$DEBUG && warn "linking custodiat into place\n";
	Sauce::Util::linkfile('/usr/local/sbin/poprelayd.custodiat', '/etc/cron.quarter-daily/poprelayd.custodiat');
} else {
	$DEBUG && warn "unlinking custodiat\n";
	Sauce::Util::unlinkfile('/etc/cron.quarter-daily/poprelayd.custodiat');
}

Sauce::Service::service_restart_inetd();
$cce->bye("SUCCESS");
exit(0);
