#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
# $Id: enableAM.pl,v 1.3 2001/08/11 01:45:33 jcheng Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# 
#
use strict;
use CCE;

my $cce = new CCE;
$cce->connectfd();

# retreive object data:
my $oid = $cce->event_oid();
my $ns = $cce->event_namespace();
my ($ok, $newobj, $oldobj) = $cce->get($oid, $ns);

if (!$oid || !$ns) {
  $cce->bye('FAIL', 'Bad oid or namespace');
  exit(1);
}

my %nsmap = (
	enableSMTP => "SMTP",
	enableImap => "IMAP",
	enablePop => "POP3"
);
my @oids = $cce->find("ActiveMonitor");
my $prop;

foreach $prop (("enableSMTP", "enableImap", "enablePop")) {
	my ($oldval, $newval);
	$oldval = $oldobj->{$prop} ? 1 : 0;
	$newval = $newobj->{$prop} ? 1 : 0;

	# only set on a real change of boolean value, not just string value
	if (!($oldval eq $newval)) {
		$cce->set($oids[0], $nsmap{$prop}, {enabled => $newval});
	}
}

if ($newobj->{enableSMTP} || $newobj->{enableImap} || $newobj->{enablePop}) {
    $cce->set($oids[0], 'Email', { 'enabled' => 1 });
} else {
    $cce->set($oids[0], 'Email', { 'enabled' => 0 });
}

$cce->bye('SUCCESS');
exit(0);
