#!/usr/bin/perl -I/usr/sausalito/perl/ -w
# $Id: forward.pl,v 1.12 2001/07/31 02:03:27 pbose Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.

use strict;

use CCE;

use Sauce::Config;
use Sauce::Util;

my $cce = new CCE ( Namespace => "Email",
                    Domain => 'base-email' );

$cce->connectfd();

my $errors;

my($success, $user, $old, $new) = $cce->get($cce->event_oid());

my $mail = $cce->event_object();

my @pwent = getpwnam($user->{name});
my $forward_file = $pwent[7] . '/.forward';

my $data = "";
my $bad_local_users = "";

if (! $mail->{forwardEnable}) {
	$data .= "# forwarding not enabled\n";
} else {
	for my $forward (CCE->scalar_to_array($mail->{forwardEmail})) {
		if(&valid_forward($forward)) {
			$data .= "$forward\n";
		} else {
			$bad_local_users ? ($bad_local_users .=	", $forward") : ($bad_local_users .= $forward);
		}	
	}
}
if ($mail->{forwardEnable} && $mail->{forwardSave}) {
	$data .= "\\" . $user->{name};
}

Sauce::Util::replaceblock( $forward_file,
	'# forward.pl: Do not edit below this line',
	$data,
	'# forward.pl: Do not edit above this line',
	0644);

# .forward needs to be 0644 or sendmail ignores it
Sauce::Util::chmodfile(0644, $forward_file);
Sauce::Util::chownfile(@pwent[2,3], $forward_file);

if ($bad_local_users) {
	$cce->warn("nonExistentUser", { 'users' => "$bad_local_users" });
	$cce->bye("FAIL");
	exit(1);
}

$cce->bye("SUCCESS");
exit(0);

sub valid_forward {
	my $forward = shift;

	# check for fully qualified email address
	if ($forward =~ /^[\w\-\_\.]+\@[\w\-\_\.]+$/) {
		return 1;
	}

	# check if a the forward is a valid local user name
	if (not getpwnam($forward)) {
		return 0;
	}

	return 1;
}
