#!/usr/bin/perl -w -I/usr/sausalito/perl/ -I/usr/sausalito/handlers/base/email/
# $Id: local_hosts.pl,v 1.3 2001/06/13 17:40:37 will Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.

use strict;
use CCE;
use Email;
use Sauce::Util;

my $Sendmail_cw = Email::SendmailCW;

my $cce = new CCE( Domain => 'base-email' );

$cce->connectfd();

my $sys_obj = $cce->event_object();
my $new_sys = $cce->event_new();
my ($ok, $email) = $cce->get($cce->event_oid(), 'Email');

if (not $ok) {
	$cce->bye('FAIL');
	exit(1);
}

if ($new_sys->{hostname} || $new_sys->{domainname} || 
	($cce->event_property() eq 'acceptFor')) {
	if(!Sauce::Util::replaceblock($Sendmail_cw,
		'# Cobalt System Section Begin',
		&make_sendmail_cw($email, $sys_obj),
		'# Cobalt System Section End')
		) {
		$cce->warn('[[base-email.cantEditFile]]', 
				{ 'file' => Email::SendmailCW });
		$cce->bye('FAIL');
		exit(1);
	}
}

$cce->bye('SUCCESS');
exit(0);

sub make_sendmail_cw
{
	my $obj = shift;
	my $sys = shift;

	my @aliases;

	@aliases = $cce->scalar_to_array($obj->{acceptFor});
	
	# always accept email addressed to this machine
	# there is a flag for this in cce, but no ui widget
	# don't know why you would not want to accept mail to your fqdn
	push @aliases, $sys->{hostname} . "." . $sys->{domainname};

	return join("\n",@aliases);
}


