#!/usr/bin/perl -w -I /usr/sausalito/perl -I/usr/sausalito/handlers/base/email
# Copyright 2001 Sun Microsystems, Inc.  All rights reserved.
# $Id: newaliases.pl,v 1.2.2.1 2002/04/10 04:30:25 pbaltz Exp $
#
# run the newaliases command for EmailAliases with local_alias set to
# true

use CCE;
use Sauce::Util;
use Email;

my $DEBUG = 0;

my $cce = new CCE;
$cce->connectfd();

my $alias = $cce->event_object();
my $alias_old = $cce->event_old();

my $run_program = 0;

# figure out if it should actually be run
if ($cce->event_is_destroy() && $alias_old->{local_alias})
{
    $run_program = 1;
}
elsif ($alias->{local_alias})
{   # local_alias was just set or some other property the local alias
    # depends on
    $run_program = 1;
}
elsif ($alias_old->{local_alias} != $alias->{local_alias})
{   # local_alias was toggled
    $run_program = 1;
}

if ($run_program)
{
    $DEBUG && print STDERR "RUNNING NEWALIASES\n";
    Sauce::Util::modifyfile(&Email::Aliases . '.db');
    Sauce::Util::modifyfile(&Email::MajordomoAliases . '.db');
    system('/usr/bin/newaliases', '-O', 'DisableGetHostByAddr=True');

    if ($?)
    {
        $cce->bye('FAIL', '[[base-email.cantUpdateLocalAliases]]');
        exit(1);
    }
}

$cce->bye('SUCCESS');
exit(0);
